package pl.kielce.tu;

import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;

import java.io.IOException;
import java.io.OutputStream;
import java.nio.charset.StandardCharsets;
import java.util.regex.Pattern;

public class SimpleHttpHandler implements HttpHandler {

    private String prepareMainResponse() {
        StringBuilder response = new StringBuilder();
        response
                .append("<html>")
                .append("<head></head>")
                .append("<body>")
                .append("<form action=\"\" method=\"GET\">")
                .append("<label for=\"name\">Input Your name: </label>")
                .append("<input name=\"name\" id=\"name\">")
                .append( "<button>Submit</button>")
                .append("</form>")
                .append("</body>")
                .append( "</html>");
        return response.toString();
    }

    private String prepareGreetingsResponse(String requestParameters) {
        StringBuilder response = new StringBuilder();
        String name = java.net.URLDecoder.decode(requestParameters.split("=")[1], StandardCharsets.UTF_8);
        response
                .append("<html>")
                .append("<head></head>")
                .append("<body>")
                .append("Hello, ")
                .append(name)
                .append("!")
                .append("</body>")
                .append("</html>");
        return response.toString();
    }
    private String prepareValidatedGreetingsResponse(String requestParameters) {
        StringBuilder response = new StringBuilder();
        String name = java.net.URLDecoder.decode(requestParameters.split("=")[1], StandardCharsets.UTF_8);
        Pattern pattern = Pattern.compile("<[a-z]*>[a-z]*\\(.*\\)<.*>");
        if(pattern.matcher(name).find())
            name = "You are doing something nasty";
        else
            name = "Hello, " + name;
        response
                .append("<html>")
                .append("<head></head>")
                .append("<body>")
                .append(name)
                .append("!")
                .append("</body>")
                .append("</html>");
        return response.toString();
    }

    @Override
    public void handle(HttpExchange exchange) throws IOException {
        String requestParameters = exchange.getRequestURI().toString();
        String page;
        if(!requestParameters.contains("name"))
            page = prepareMainResponse();
         else
             page = prepareValidatedGreetingsResponse(requestParameters);
        exchange.sendResponseHeaders(200,page.length());
        OutputStream stream = exchange.getResponseBody();
        stream.write(page.getBytes());
        stream.close();
    }
}
